#
# Conditional build:
%bcond_without	static_libs	# don't build static library
%bcond_without	apidocs		# do not build and package API docs
%bcond_without	python		# smixer-python binding
%bcond_with	python2		# python 2.x instead of python 3.x for smixer pymodules
%bcond_with	resmgr		# Resource Manager support

Summary:	Advanced Linux Sound Architecture (ALSA) - Library
Summary(es.UTF-8):	Advanced Linux Sound Architecture (ALSA) - Biblioteca
Summary(pl.UTF-8):	Advanced Linux Sound Architecture (ALSA) - Biblioteka
Summary(pt_BR.UTF-8):	Biblioteca para o ALSA (Advanced Linux Sound Architecture)
Summary(ru.UTF-8):	Библиотека API для работы с драйвером ALSA
Summary(uk.UTF-8):	Бібліотека API для роботи з драйвером ALSA
Name:		alsa-lib
Version:	1.2.4
# alsa-*-conf tarballs are not released for each patch version
%define	confver	1.2.4
Release:	1
License:	LGPL v2.1+
Group:		Libraries
Source0:	ftp://ftp.alsa-project.org/pub/lib/%{name}-%{version}.tar.bz2
# Source0-md5:	875184646a96e34bbe7a91925cd7b2ba
Source1:	%{name}-modprobe.conf
Source2:	%{name}-asound.conf
Source3:	smixer.conf
Source4:	ftp://ftp.alsa-project.org/pub/lib/alsa-topology-conf-%{confver}.tar.bz2
# Source4-md5:	a5934e86c726a16d3c1bbce4f04aa1bc
Source5:	ftp://ftp.alsa-project.org/pub/lib/alsa-ucm-conf-%{confver}.tar.bz2
# Source5-md5:	176f06dc581b6574dd7399e335903c4b
URL:		https://www.alsa-project.org/
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake
BuildRequires:	doxygen
BuildRequires:	libtool >= 1.4
%if %{with python}
%if %{with python2}
BuildRequires:	python-devel >= 1:2.4
BuildRequires:	python-modules >= 1:2.4
%else
BuildRequires:	python3-devel >= 1:3.2
BuildRequires:	python3-modules >= 1:3.2
%endif
%endif
%{?with_resmgr:BuildRequires:	resmgr-devel}
BuildRequires:	tar >= 1:1.15
BuildConflicts:	alsa-lib <= 0.4.0
Obsoletes:	alsa-libs
Conflicts:	alsa-utils < 1.0.20-3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Advanced Linux Sound Architecture (ALSA) - Library

Features:
- general
	- modularized architecture
	- support for versioned and exported symbols
	- full proc filesystem support - /proc/sound
- ISA soundcards
	- support for 128k ISA DMA buffer
- mixer
	- new enhanced API for applications
	- support for unlimited number of channels
	- volume can be set in three ways (percentual (0-100), exact and
	  decibel)
	- support for mute (and hardware mute if hardware supports it)
	- support for mixer events
		- this allows two or more applications to be synchronized
- digital audio (PCM)
	- new enhanced API for applications
	- full real duplex support
	- full duplex support for SoundBlaster 16/AWE soundcards
	- digital audio data for playback and record should be read back using
	  proc filesystem
- OSS/Lite compatibility
	- full mixer compatibity
	- full PCM (/dev/dsp) compatibility

%description -l pl.UTF-8
Advanced Linux Sound Architecture (ALSA) - Biblioteka

Możliwości:
- generalne
	- zmodularyzowana architektura
	- pełne wsparcie dla systemu plików proc - /proc/sound
- karty dźwiękowe ISA
	- obsługa bufora 128k ISA DMA
- mikser
	- nowe rozszerzone API dla aplikacji
	- obsługa nielimitowanej liczby kanałów
	- głośność może być ustawiana na trzy różne sposoby (procentowo
	  (0-100), liniowo oraz w skali decybelowej)
	- obsługa wyciszania (oraz sprzętowego wyciszania)
	- obsługa zdarzeń miksera
		- to pozwala dwum lub większej liczbie aplikacji się synchronizować
- cyfrowe audio (PCM)
	- nowe rozszerzone API dla aplikacji
	- pełna, prawdziwa obsługa trybu duplex
	- pełna obsługa trybu duplex dla kart SoundBlaster 16/AWE
	- dane cyfrowego dźwięku dla odtwarzania i nagrywania powinny być
	  odczytywane poprzez system plików /proc
- kompatybilność z OSS/Lite
	- pełna kompatybilność miksera
	- pełna kompatybilność PCM (/dev/dsp)

%description -l pt_BR.UTF-8
Bibliotecas para o ALSA. Esse pacote é necessário para rodar programas
Linux queusam o driver de som ALSA.

%description -l ru.UTF-8
Библиотека API для работы с драйвером ALSA.

%description -l uk.UTF-8
Бібліотека API для роботи з драйвером ALSA.

%package devel
Summary:	Advanced Linux Sound Architecture (ALSA) - header files
Summary(es.UTF-8):	Archivos de desarrollo de ALSA
Summary(pl.UTF-8):	Advanced Linux Sound Architecture (ALSA) - pliki nagłówkowe
Summary(pt_BR.UTF-8):	Arquivos de desenvolvimento do ALSA (Advanced Linux Sound Architecture)
Summary(ru.UTF-8):	Библиотека API для работы с драйвером ALSA - файлы программиста
Summary(uk.UTF-8):	Бібліотека API для роботи з драйвером ALSA - файли програміста
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Obsoletes:	alsa-devel
Obsoletes:	alsa-lib-devel-doc

%description devel
Advanced Linux Sound Architecture (ALSA) - header files.

%description devel -l es.UTF-8
Este paquete contiene los archivos necesarios para compilar programas
que usan la biblioteca del sistema ALSA. No es necesario instalarlo si
lo que se desea es solamente ejecutar programas.

%description devel -l pl.UTF-8
Advanced Linux Sound Architecture (ALSA) - pliki nagłówkowe.

%description devel -l pt_BR.UTF-8
Esse pacote contém os arquivos necessários para compilar programas que
usam a biblioteca do ALSA. Não é necessário instalar esse pacote para
apenas rodar programas.

%description devel -l ru.UTF-8
Библиотеки разработчика и хедера для библиотеки API для работы с
драйвером ALSA.

%description devel -l uk.UTF-8
Бібліотеки програміста та хедери для бібліотеки API для роботи з
драйвером ALSA.

%package static
Summary:	Advanced Linux Sound Architecture (ALSA) - static library
Summary(pl.UTF-8):	Advanced Linux Sound Architecture (ALSA) - biblioteka statyczna
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento com a alsa-lib
Summary(ru.UTF-8):	Статическая библиотека API для работы с драйвером ALSA
Summary(uk.UTF-8):	Статична бібліотека API для роботи з драйвером ALSA
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Advanced Linux Sound Architecture (ALSA) - static library.

%description static -l pl.UTF-8
Advanced Linux Sound Architecture (ALSA) - biblioteka statyczna.

%description static -l pt_BR.UTF-8
Bibliotecas estáticas para desenvolvimento com a alsa-lib

%description static -l ru.UTF-8
Статическая библиотека API для работы с драйвером ALSA.

%description static -l uk.UTF-8
Статична бібліотека API для роботи з драйвером ALSA.

%package apidocs
Summary:	ALSA Library API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki ALSA
Group:		Documentation
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description apidocs
API and internal documentation for ALSA Library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki ALSA.

%package smixer-python
Summary:	Python binding module for ALSA Mixer Interface
Summary(pl.UTF-8):	Moduł wiązania Pythona dla interfejsu miksera architektury ALSA
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description smixer-python
Python binding module for ALSA Mixer Interface.

%description smixer-python -l pl.UTF-8
Moduł wiązania Pythona dla interfejsu miksera architektury ALSA.

%prep
%setup -q
cp -p %{SOURCE3} src/conf

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
configure_opts="\
	--disable-silent-rules \
	%{!?with_python:--disable-python} \
	%{?with_python2:--enable-python2} \
	%{?with_resmgr:--enable-resmgr} \
	--enable-mixer-modules \
	--enable-mixer-pymods
"

%if %{with static_libs}
install -d build-static
cd build-static
../%configure $configure_opts \
	--disable-shared \
	--enable-static
%{__make}
cd ..
%endif

install -d build-shared
cd build-shared
../%configure $configure_opts \
	--enable-shared \
	--disable-static

%{__make}
%{?with_apidocs:%{__make} doc}
cd ..

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/%{_lib},%{_sysconfdir}/alsa/conf.d,%{_datadir}/alsa/alsa.conf.d,/etc/modprobe.d}

%if %{with static_libs}
%{__make} -C build-static/src install-libLTLIBRARIES \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build-shared install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_libdir}/libasound.so.* $RPM_BUILD_ROOT/%{_lib}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libasound.so
ln -sf /%{_lib}/$(cd $RPM_BUILD_ROOT/%{_lib}; echo libasound.so.*.*) \
	$RPM_BUILD_ROOT%{_libdir}/libasound.so

tar xf %{SOURCE4} --strip-components=1 -C $RPM_BUILD_ROOT%{_datadir}/alsa alsa-topology-conf-%{confver}/topology
tar xf %{SOURCE5} --strip-components=1 -C $RPM_BUILD_ROOT%{_datadir}/alsa alsa-ucm-conf-%{confver}/ucm alsa-ucm-conf-%{confver}/ucm2

install -D utils/alsa.m4 $RPM_BUILD_ROOT%{_aclocaldir}/alsa.m4
install %{SOURCE1} $RPM_BUILD_ROOT/etc/modprobe.d/alsa-base.conf
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/asound.conf

%{__rm} $RPM_BUILD_ROOT%{_libdir}/alsa-lib/smixer/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc doc/asoundrc.txt
%attr(755,root,root) %{_bindir}/aserver
%attr(755,root,root) /%{_lib}/libasound.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libasound.so.2
%attr(755,root,root) /%{_libdir}/libatopology.so.*.*.*
%attr(755,root,root) %ghost /%{_libdir}/libatopology.so.2
%dir %{_libdir}/alsa-lib
%dir %{_libdir}/alsa-lib/smixer
%attr(755,root,root) %{_libdir}/alsa-lib/smixer/smixer-ac97.so
%attr(755,root,root) %{_libdir}/alsa-lib/smixer/smixer-hda.so
%attr(755,root,root) %{_libdir}/alsa-lib/smixer/smixer-sbase.so
%dir %{_datadir}/alsa
%{_datadir}/alsa/cards
%{_datadir}/alsa/pcm
%{_datadir}/alsa/topology
%{_datadir}/alsa/ucm
%{_datadir}/alsa/ucm2
%{_datadir}/alsa/alsa.conf
# directory for "global" config files (not accessed directly, but through symlinks in %{_sysconfdir}/alsa/conf.d)
%dir %{_datadir}/alsa/alsa.conf.d
%{_datadir}/alsa/smixer.conf
%dir %{_sysconfdir}/alsa
# directory for "local" config files (loaded from %{_datadir}/alsa/alsa.conf)
%dir %{_sysconfdir}/alsa/conf.d
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/asound.conf
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/alsa-base.conf

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libasound.so
%attr(755,root,root) %{_libdir}/libatopology.so
%{_libdir}/libasound.la
%{_libdir}/libatopology.la
%{_includedir}/sys/asoundlib.h
%{_includedir}/alsa
%{_includedir}/asoundlib.h
%{_aclocaldir}/alsa.m4
%{_pkgconfigdir}/alsa.pc
%{_pkgconfigdir}/alsa-topology.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libasound.a
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc build-shared/doc/doxygen/html/*
%endif

%if %{with python}
%files smixer-python
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/alsa-lib/smixer/smixer-python.so
%endif
%changelog
* Sat Oct 31 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/alsa-lib.git;a=log;h=master

* Thu Oct 29 2020 Jan Palus <atler@pld-linux.org> cd798c1
- updated *-conf version

* Tue Oct 27 2020 Jan Palus <atler@pld-linux.org> ae322d2
- up to 1.2.4

* Sun Jul 19 2020 Jan Palus <atler@pld-linux.org> 6bc2a09
- up to 1.2.3.2

* Thu Jun 11 2020 Jan Palus <atler@pld-linux.org> e2cb938
- up to 1.2.3

* Sun Mar 08 2020 Jakub Bogusz <qboosh@pld-linux.org> 8df1c42
- updated conf tarballs

* Sat Feb 29 2020 Jan Palus <atler@pld-linux.org> 9e011c4
- up to 1.2.2

* Wed Nov 20 2019 Jakub Bogusz <qboosh@pld-linux.org> ecc3267
- updated to 1.2.1.1
- package topology and ucm configs (v1.2.1)

* Mon Nov 18 2019 Jakub Bogusz <qboosh@pld-linux.org> 6049f42
- keep python<3.8 support

* Sat Nov 16 2019 Jan Palus <atler@pld-linux.org> b954582
- up to 1.2.1

* Sat Nov 02 2019 Jan Rękorajski <baggins@pld-linux.org> 2588251
- fix building with python 3.8
- rel 3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 370b685
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun May 19 2019 Jan Palus <atler@pld-linux.org> b8e8478
- up to 1.1.9

* Thu Jan 10 2019 Jan Palus <atler@pld-linux.org> d90d5ed
- up to 1.1.8

* Sun Oct 21 2018 Jakub Bogusz <qboosh@pld-linux.org> f50a2c4
- release 2: added conf.d dirs

* Sat Oct 20 2018 Jakub Bogusz <qboosh@pld-linux.org> 8d1458c
- updated to 1.1.7

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 731531e
- release 2 (by relup.sh)

* Mon Apr 09 2018 Jakub Bogusz <qboosh@pld-linux.org> 82bf787
- now uses python3 by default, added python2 bcond

* Sun Apr 08 2018 Jan Palus <atler@pld-linux.org> 0784d03
- up to 1.1.6

* Sat Nov 25 2017 Jan Palus <atler@pld-linux.org> 12fef44
- up to 1.1.5

* Tue Jun 06 2017 Jakub Bogusz <qboosh@pld-linux.org> 830b8cb
- updated to 1.1.4.1

